#include <graphics.h>
#include <math.h>
#include <stdio.h>
#include <dos.h>
#include <stdlib.h>
#include <time.h>
#include <conio.h>
#include <alloc.h>
#include <errno.h>
#include "muslib.c"
#include "mouse.c"
#include "arabic.c"
#define ENTER 13
#define UP 72
#define DOWN 80
#define F1 59
#define beep putch(7)
#define ESC 27
int far *pt;
float ratioy,ratiox;
int positionx,positiony;
int buffer[4000];
int slow=0;

/*---------------------- main () --------------------------------------*\
| This is the main function of the program.                             |
| Command line parameters technique is used here to enable the user to  |
| skip the introduction if he types the program name followed by the    |
| word "nointro".                                                       |
|       IN  : argc, the ny=umber of command line parameters,            |
|             argv, pointers to the command line parameters themselves. |
|       OUT : NONE.                                                     |
\*---------------------------------------------------------------------*/
main(int argc,char *argv[])
{
int alamuna1[]={-130,-60,130,70,120,70,120,75,130,75,130,85,95,85,95,15,
103,15,103,75,110,75,110,60,130,60,-90,-15,90,85,70,85,70,100,43,100,43,85,
7,85,7,15,15,15,15,75,32,75,32,60,40,60,40,75,82,75,82,15,90,15,-52,-85,
52,93,62,93,62,85,52,85,-20,-50,20,57,27,57,27,50,20,50};
					/* the coordinates of word ALAMUNA */
int alamuna2[]={-160,-15,160,85,152,85,152,15,160,15,-148,-15,148,85,95,85,95,105,
60,105,60,97,88,97,88,75,105,75,105,60,125,60,125,70,115,70,115,75,140,75,
140,15,148,15,-70,-60,70,85,43,85,43,105,7,105,7,75,15,75,15,98,35,98,35,75,
62,75,62,60,70,60,-47,-90,47,97,54,97,54,90,47,90};
					/* the coordinates of word ALARABI */

char *film[]={  "      fvl[m",
		"  Hpl] lpl] vqh","",
		"      l,sdrd",
		"    shlp j,tdr","",
		"      Yojfhv",
		"  Hpl] lpl] vqh","",
		"      lshfrm",
		"  uhgl hg;lfd,jv"};
int cnt;

if(farcoreleft()>=36000)        /* if enough memory left in heap */
	pt=(int far*)farmalloc(35496); /* reserve meory to hold letters info */
else
	{slow=1;init16=0;}      /* otherwise, mark slow mode */

if(strcmp(argv[1],"nointro")==0)        /* if first argument is "nointro" */
	{
	initialize_graph();             /* prepare screen */
	start_mouse();disable_cursor(); /* detect mouse and hide cursor */
	setfillstyle(1,14);bar(0,0,639,349);
	setcolor(6);rectangle(0,0,639,349);line(1,325,639,325);
	flags_frame();                  /* draw flags as a frame */
	enable_cursor();                /* show cursor */
	main_menu();                    /* display main menu */
	}

initialize_graph();                     /* prepare screen */
start_mouse();disable_cursor();         /* detect mouse and hide cursor */
ratioy=0.7;ratiox=0.7;positionx=210;positiony=100;
setactivepage(1);setfillstyle(1,14);bar(0,0,639,349);
for(cnt=0;cnt<=10;cnt++)
	arabic_text(film[cnt],400,10+(cnt*25),0,1);
setactivepage(0);
setfillstyle(1,14);bar(0,0,639,349);
setcolor(6);rectangle(0,0,639,349);line(1,325,639,325);
arabic_text("Yqy' Hd ltjhp ggrhzlm hgvzdsdm",500,328,0,1);
setcolor(0);draw(alamuna2,(sizeof(alamuna2)/2-1));      /* draw ALAMUNA */
positionx=340;draw(alamuna1,(sizeof(alamuna1)/2-1));    /* draw ALARABI */
randomize();flags_frame();                      /* display random flags */
setactivepage(1);getimage(200,2,415,52,buffer);
setactivepage(0);putimage(220,175,buffer,COPY_PUT);
enable_cursor();                                /* show cursor */
play_music();                                   /* play watani habibi */
if(!kbhit())                                    /* if no key was pressed */
	{
	speak();                                /* Say "Alamuna Alarabi"*/
	for(cnt=1;cnt<=116;cnt++)
		{
		setactivepage(1);disable_cursor();
		getimage(200,(2*cnt),415,50+(2*cnt),buffer);
		enable_cursor();delay(5);
		setactivepage(0);disable_cursor();
		putimage(220,175,buffer,COPY_PUT);enable_cursor();delay(5);
		if(kbhit() || check_buttons()) cnt=200;
				/* if a key was pressed, get out of loop */
		}
	}
enable_cursor();                                /* show cursor */
while(!kbhit())                                 /* if no key was pressed */
   check_buttons();                             /* check the mouse status */
if(getch()==0) getch();                         /* empty the keyb. buffer */
disable_cursor();                               /* hide cuyrsor */
arabic_text("Yqy' Hd ltjhp ggrhzlm hgvzdsdm",500,328,0,1);
enable_cursor();                                /* show cursor */
while(1) main_menu();                           /* display main menu */
}

/*----------------------speak() --------------------------------------*\
| This function is responsible for reading the speech.dat file and     |
| playing the frequencies included it at a high speech to produce the  |
| speech . The compiled version was compiled using another function    |
| This function comes as a gift with a covox sound card so it's        |
| copyrighted so I wrote a function like it in the C language but      |
| This will produce a sound with less quaality than the covox function |
| If you compile with this you must change the delay value mentioned   |
| down to match your system's speed . I included the source with the   |
| covox function in the "assist" <dir> under the name calamuna .       |
| In : None                                                            |
| Out: None:                                                           |
\*--------------------------------------------------------------------*/
speak()
{
FILE *fptr;
char speech[8500];
int cnt,cnt1;
fptr=fopen("speech.dat","rb");		     /* open the speech.dat */
fread(speech,1,8500,fptr);		     /* read half its contents */
for(cnt=0;cnt<=8500;cnt++)
	{
	sound(speech[cnt]);		     /* sound the freq */
	for(cnt1=0;cnt1<=25;cnt1+=2) cnt1--; /*delay value (change) */
	nosound();			     /* stop the freq. */
	}
fread(speech,1,8500,fptr);		     /* read the rest of contents*/
for(cnt=0;cnt<=8500;cnt++)
	{
	sound(speech[cnt]);                  /* sound the freq */
	for(cnt1=0;cnt1<=25;cnt1+=2) cnt1--; /*delay value (change) */
	nosound();                           /* stop the freq. */
	}
fclose(fptr);                                /* close the file*/
}

/*---------------------- brushed_background () ------------------------*\
| This function fills the background with a brshed (gradual increase in |
| color intensity) background.                                          |
| It uses the concept of user-defined filling style to perform that     |
| function.                                                             |
|       IN  : c: the color of background.                               |
|       OUT : NONE.                                                     |
\*---------------------------------------------------------------------*/
brushed_background(c)
int c;
{
char f3[]={0,32,0,0,0,2,0,0},f6[]={32,0,2,0,128,0,8,0},
f12[]={32,2,128,8,32,2,128,8},f25[]={68,17,68,17,68,17,68,17},
f37[]={146,41,148,73,164,73,146,73},f50[]={85,170,85,170,85,170,85,170},
f62[]={109,214,107,182,91,182,109,182},f75[]={187,238,187,238,187,238,187,238},
f87[]={223,253,127,247,223,253,127,247};
setfillpattern(f6,c);bar(0,35,639,70);
setfillpattern(f12,c);bar(0,70,639,105);
setfillpattern(f25,c);bar(0,105,639,140);
setfillpattern(f37,c);bar(0,140,639,175);
setfillpattern(f50,c);bar(0,175,639,210);
setfillpattern(f62,c);bar(0,210,639,245);
setfillpattern(f75,c);bar(0,245,639,280);
setfillpattern(f87,c);bar(0,280,639,315);
setfillstyle(1,c);bar(0,315,639,349);
}

show_about_page()
{
}

/*---------------------- f1_message () --------------------------------*\
| This function displays a message at the bottom of the screen that     |
| tells the user to press F1 for help.                                  |
|       IN  : NONE                                                      |
|       OUT : NONE                                                      |
\*---------------------------------------------------------------------*/
f1_message()
{
arabic_text("hqy'    H, .v hgtHvm hG,s' gglshu]m",536,325,0,1);
setcolor(11);outtextxy(460,332,"F1");
}

/*---------------------- reverse () -----------------------------------*\
| This function reverses the colour of a portion of the screen.         |
|       IN : x1,y1:start x,y coordinates of the area                    |
|            x1,y2:end x,y coordinates of the area                      |
|       OUT: NONE                                                       |
\*---------------------------------------------------------------------*/
reverse(x1,y1,x2,y2)
int x1,y1,x2,y2;
{
getimage(x1,y1,x2,y2,buffer);                   /* get the image */
putimage(x1,y1,buffer,NOT_PUT);                 /* put it reversed */
}

/*---------------------- initialize_graph () --------------------------*\
| This function puts the computer in the graphics mode.                 |
|       IN  :NONE.                                                      |
|       OUT :NONE.                                                      |
\*---------------------------------------------------------------------*/
initialize_graph()
{
int gdriver=EGA,gmode=EGAHI;

registerbgidriver(EGAVGA_driver);       /* to overcome disk problems */
initgraph(&gdriver,&gmode,"");          /* initialize graphics mode */
}

/*---------------------- main_menu () ---------------------------------*\
| This function displays the main menu.                                 |
|       IN  : NONE.                                                     |
|       OUT : NONE.                                                     |
\*---------------------------------------------------------------------*/
main_menu()
{
char *menu_items[]={"  hgrhzlm hgvzdsdm",
		    "jJhvdJo hguhgl hguvfd",
		    "[yvhtdm hguhgl hguvfd",
		    "jyddv aJ;Jg hg;JjhfJm",
		    "oJJJJJJJJJJJJJJJJJv,["};
int cnt,end=0,choice=0;
char ch;

disable_cursor();                       /* hide cursor */
f1_message();                           /* display a help message */
setfillstyle(1,7);bar(175,90,470,215);
setfillstyle(1,15);setcolor(0);bar(170,85,465,210);
for(cnt=0;cnt<=4;cnt++)
	{                               /* display menu items */
	setcolor(6);rectangle(170,85+(25*cnt),465,110+(25*cnt));
	arabic_text(menu_items[cnt],442,88+(25*cnt),0,1);
	}
reverse(170,111,465,135);               /* highlight first choice */
enable_cursor();                        /* show cursor */
while(end!=1)                           /* while user want to go on... */
	{
	if(kbhit() || check_buttons()==1)
		{       /* if a key or a button was pressed ... */
		ch=getch();                     /* get key */
		if(ch==0)                       /* if extended key */
		{
		ch=getch();                     /* get Scan code */
		if(ch!=59)                      /* if not F1 */
		{choice=menu(170,111,295,24,3,choice,ch,1);}
						/* perform user's action */
		else help(0);                   /* if F1, display help */
		}
		else                            /* if a Normal key */
			switch(ch)
				{       /* examine the pressed key */
				case ENTER: enter_music();      /* if ENTER */
					switch(choice)
						{       /* what choice */
						case 0: execl("history.ovl",0);
							break;
						case 1: execl("geo.ovl",0);
							break;
						case 2: change_current_font();
							break;
						case 3: user_exit();end=1;
							break;
						}
					break;
				case ESC: esc_music();  /* if ESC */
					  closegraph();exit(0);break; /* xit */
				default: beep;

				}
		}
	}
}

/*---------------------- user_exit () ---------------------------------*\
| This function displays the last screen after the user chooses to exit | 
| the program from the main menu.                                       |
|       IN  : NONE.                                                     |
|       OUT : NONE.                                                     |
\*---------------------------------------------------------------------*/
user_exit()
{
int cnt,end=0,choice=0;
char ch,*menu_items[]={"       ov,[","oJJv,[ lJJJcrJJJj","oJJv,[ kJJJihzJJd"};

disable_cursor();                               /* hide cursor */
setfillstyle(1,7);bar(130,145,400,220);
setfillstyle(1,15);setcolor(0);bar(125,140,395,215);
setcolor(6);rectangle(125,140,395,215);
for(cnt=0;cnt<=2;cnt++)
	{                                       /* display items */
	setcolor(6);rectangle(125,140+(25*cnt),395,165+(25*cnt));
	arabic_text(menu_items[cnt],360,143+(25*cnt),0,1);
	}
reverse(125,166,394,190);                       /* highlight 1st item */
enable_cursor();                                /* show cursor */
while(end!=1)
	{                       /* while user does not want to get back */
	if(kbhit() || check_buttons()==1)
		{               /* if a key or a button was pressed */
		ch=getch();             /* get key from keyboard buffer */
		if(ch==0)                       /* if an extended key */
		{
		ch=getch();                     /* get SCAN code */
		if(ch!=59)                      /* if not F1 */
		{choice=menu(125,166,269,24,1,choice,ch,1);}
						/* perform user's action */
		else help(0);                   /* else display help */
		}
		else                            /* if a normal key */
			switch(ch)
				{       /* what key? */
				case ENTER: enter_music();      /* ENTER */
					switch(choice)
						{       /* which choice */
						case 0: closegraph();   /* SHELL */
							textmode(C80);
							gotoxy(1,1);
							printf("Type EXIT to return to \"Our Arab World\" .");
							system("command.com");
							execl("alamuna.exe","f","nointro",0);
							exit(0);
						case 1: closegraph();textmode(C80);exit(0);break;     /* exit */
						}
					break;
				case ESC: esc_music();
					  execl("alamuna.exe","f","nointro",0); /* ESC */
					  break;
				default: beep;
				}
		}
	}
}

/*-------------------------change_current_font()--------------------------*\
|This function changes the current font by swaping the names of the files  |
|"usedfont.dat" and "scndfont.dat" and then it re-executes the program     |
|but the arabic function will use the "usedfont.dat" with its new content  |
|of the new font so the font will change on the screen .                   |
|       IN  : NONE.                                                        |
|       OUT : NONE.                                                        |
\*------------------------------------------------------------------------*/
change_current_font()
{
rename("usedfont.dat","tempfile.dat");
rename("scndfont.dat","usedfont.dat");
rename("tempfile.dat","scndfont.dat");
execl("alamuna.exe","f","nointro",0);
}

/*---------------------- flags_frame () -------------------------------*\
| This function draws the frame of flags around the first screen.       |
|       IN  : NONE.                                                     |
|       OUT : NONE.                                                     |
\*---------------------------------------------------------------------*/
flags_frame()
{
int cnt;
int countryno[]={1,4,8,17,11,13};
for(cnt=0;cnt<=2;cnt++)
	{                                       /* diplay slags */
	flags(countryno[cnt],10+cnt*220,10);
	flags(countryno[cnt+3],10+cnt*220,230);
	}
flags(14,10,125);flags(3,450,125);
}
/*---------------------- load_draw_array () ---------------------------*\
| This function opens a file and reads its contents and sends it to the |
| draw() to be drawn on the screen.                                     |
|               IN : filename : The filename of the file containing the |
|                               image array                             |
|               OUT: NONE                                               |
\*---------------------------------------------------------------------*/
load_draw_array(filename)
char *filename;
{
FILE *fptr;
int handle,array[250],array_length;
if((fptr=fopen(filename,"rb"))==NULL)   /* open the required file */
	file_error(filename);           /* exit on error */
handle=fileno(fptr);                    /* get file handler */
array_length=filelength(handle)/2;      /* get file length */
fread(array,2,array_length,fptr);       /* read array contents */
fclose(fptr);                           /* close file */
draw(array,array_length-1);             /* draw contents */
}

/*---------------------- save_letters () ------------------------------*\
| This function copies the array letters to far memory if the memory is |
| available and this is checked through the variable slow which is set  |
| on to (1) in the main() function and if the far memory isn't          |
| available it does. nothing.                                           |
|       IN      : NONE                                                  |
|       OUT     : NONE                                                  |
\*---------------------------------------------------------------------*/
save_letters()
{
int i;

if(slow!=1)    /* if we are not in the slow mode, ie. letters are in memory */
for(i=0;i<=17748;i++)   /* for each character in letters[] array */
   *(pt+i)=letters[i];  /* copy it to heap */
}

/*---------------------- load_letters () ------------------------------*\
| This function copies the memory at the offset *pt to the letters[]    |
| array and this memory contains the array of the arabic letters and if |
| the memory wasn't available and the save_letters function hasn't      |
| copied the letters[] array to the memory it sets the global variable  |
| (init16) to (0) which will cause the arabic_text() function to load   |
| the arabic letters array from the file letdat.16c and this needs more |
| time than copying it from memory so, the program is in the slow mode. |
|       IN       : NONE.                                                |
|       OUT      : NONE.                                                |
\*---------------------------------------------------------------------*/
load_letters()
{
int i;
if(slow!=1)                     /* if not in slow mode */
for(i=0;i<=17748;i++)           /* for each charcater in heap */
	letters[i]=*(pt+i);             /* copy it in letters[] */
else
	init16=0;            /* else mark that characters are not in array */
}


/*---------------------- help () --------------------------------------*\
| This function is responsible for displaying help messages. It copies  |
| the part of the screen in which the help message will be displayed to | 
| page no. 1 then it recopies it back to its place in page no. 0 after  |
| the user reads th help message.                                       |
|     IN  : message : message no , It may be either 0 or 1              |
|     OUT : None .                                                      |       
\*---------------------------------------------------------------------*/    
help(message)
int message;
{
char *messages[]={"jpv; fhGsil H, fhgtHvm >","Yojv fJ     H, f.v hgtHvm hGdlk >",
"Hqy'     H, .v hgtHvm hGdsv","ggrhzlm hgshfrm >",
"Yqy'    H,     H, Hd lk H.vhv","hgtHvm hGdlk , hGdsv ggrhzlm","hgshfrm >"," "};
int enter_xs[]={398,357},enter_ys[]={120,98},esc_xs[]={440,448},
    esc_ys[]={142,98},i,end=0;

f1_music();                             /* play a tone */
save_letters();disable_cursor();  /* store letters in heap and hide cursor */
getimage(102,89,553,182,letters);       /* get background image */
setactivepage(1);putimage(102,89,letters,COPY_PUT);  /* store it on page 1 */
setactivepage(0);               /* now back to page 0 */
setfillstyle(1,6);bar(105,91,553,182);
setfillstyle(1,14);bar(102,89,550,180);
setcolor(0);rectangle(102,89,550,180);
load_letters();                 /* retrieve letters from heap */
for(i=0;i<=3;i++)               /* write message's text */
    arabic_text(messages[(message*4)+i],530,91+(22*i),0,1);
setcolor(4);
outtextxy(enter_xs[message],enter_ys[message],"Enter");
outtextxy(esc_xs[message],esc_ys[message],"Esc");
enable_cursor();                        /* show cursor */
while(end!=1)                           /* while user is reading */
	if (kbhit() || check_buttons()!=0) /* if user interrupts */
		switch(getch())
			{
			case ESC: esc_music();end=1;break;
			case 0: if((char)getch()==-127){enter_music();end=1;} else beep;
				break;
			case ENTER: enter_music();end=1;break;
			default: beep;
			}
disable_cursor();                       /* hide cursor */
setactivepage(1);getimage(102,89,553,182,letters);  /* retrive background */
setactivepage(0);putimage(102,89,letters,COPY_PUT);     /* put it back */
load_letters();                         /* retrieve letters from heap */
enable_cursor();                        /* show cursor */
}


/*---------------------- enter_music () -------------------------------*\
| This function plays the music when ENTER is pressed.                  |
|       IN      : NONE                                                  |
|       OUT     : NONE                                                  |
\*---------------------------------------------------------------------*/
enter_music()
{
play("ml o5 l32 a b c d e d a c",0);
}

/*---------------------- esc_music () ---------------------------------*\
| This function plays the music when ESC is pressed.                    |
|       IN     : NONE                                                   |
|       OUT    : NONE                                                   |
\*---------------------------------------------------------------------*/
esc_music()
{
play("ml o5 l32 f c d a b c d f",0);
}

/*---------------------- f1_music () ----------------------------------*\
| This function plays the music when F1 is pressed.                     |
|       IN   : NONE                                                     |
|       OUT  : NONE                                                     |
\*---------------------------------------------------------------------*/
f1_music()
{
play("ml l20 o5 a b d a c d f",0);
}

/*---------------------- file_error () --------------------------------*\
| This function displays an error message indicating that an error      |
| occured while opening a file.                                         |
|         IN  : fn: pointer to the filename                             |
|         OUT : NONE                                                    |
\*---------------------------------------------------------------------*/
file_error(fn)
char *fn;
{
closegraph();                   /* switch back to text mode */
printf("\nAn error occured while opening \"%s\" .",fn);
printf("\nCheck and rerun ....\n");
exit(2);                        /* exit with errorlevel of 2 */
}

/*---------------------- clear_buffer () ------------------------------*\
| This function checks the keyboard's buffer and emptys it.             |
|       IN        : NONE                                                |
|       OUT       : NONE                                                |
\*---------------------------------------------------------------------*/
clear_buffer()
{
while (kbhit())                 /* while the buffer isn't empty... */
	getch();                        /* ... remove a character from it */
}


/*---------------------- menu () --------------------------------------*\
| This function moves a menu bar with a specific width and coordinates  |
| returning the position of the bar among the choices. It has an        |
| advantage as it doesn't suspend the computer until the bar is moved   |
| and this enables doing any thing while the menu is displayed such as  |
| animating the map in the main menu or playing music .                 |
|   IN   :  xcord:  x coordinate of the menu                            |
|           ycord:  y coordinate of the menu                            |
|           width:  width of the menu                                   |
|           step:   no. of pixels betweem each choice and the next      |
|           itemsno:no. of items in the menu                            |
|           choice: current choice                                      |
|           excode: scan code of the key pressed                        |
|           stepping: the no. of pixels stepped between every item      |
|                     and another .                                     |
|   OUT  :  choice: current choice                                      |
\*---------------------------------------------------------------------*/
menu(xcord,ycord,width,step,itemsno,choice,excode,stepping)
int xcord,ycord,width,step,itemsno,choice,stepping;
char excode;
{
#define inverse_choice disable_cursor();reverse(xcord,ycord+(step*choice)+(stepping*choice),xcord+width,ycord+step+(step*choice)-1+(stepping*choice));enable_cursor()
union REGS r;
int mousex,mousey,cnt,old_choice,cntr;

switch(excode)                  
	{               /* examine the pressed key */
	case UP:        /* if UP arrow was pressed */
		if (choice!=0)          /* if old choice isn't the first */
		   {inverse_choice;choice--;inverse_choice;}    /* decrement */
		else {inverse_choice;choice=itemsno;inverse_choice;}
				/* otherwise, point to the last item */
		break;
	
	case DOWN:      /* if DOWN arrow was pressed */
		if (choice!=itemsno)    /* if old item isn't the last */
		   {inverse_choice;choice++;inverse_choice;}
		else            /* otherwise, point to the first item */
		   {inverse_choice;choice=0;inverse_choice;}
		break;

	case -127:      /* mouse button */
		mousex=get_mousex();mousey=get_mousey();
					/* get mouse coordinates */
		if (mousex>xcord && mousex<xcord+width)
			if(mousey>ycord && mousey<ycord+step+(step*itemsno))
			       /* if mouse is inside the specific rectangle */
				for(cnt=0;cnt<=itemsno;cnt++)   /* for each prvious item */
					if (mousey>ycord+(step*cnt)+(stepping*choice) &&
					    mousey<ycord+step+(step*cnt)+(stepping*choice))
						{       /* if mouse is inside that rectangle */
						inverse_choice;         /* highlight it */
						for(cntr=0;cntr<=6;cntr++)
							{
							choice=cnt;
							inverse_choice;
							delay(50);
							}
						/* insert in keyboard buffer */
						r.h.ah=5;
						r.h.ch=0x1c;
						r.h.cl=0x0d;
						int86(0x16,&r,&r);
						}
		break;
	default:
		beep;
	}
return(choice);
}


/*---------------------- clear () -------------------------------------*\
| This function clears an area of the screen which is specified by the  |
| calling function .                                                    |
|      IN    :   x1,y1 : represent the top left x,y coordinates of the  |
|                        area.                                          |
|                x2,y2 : represent the bottom right x,y coordinates of  |
|                        the area.                                      |
|      OUT   :   NONE .                                                 |
\*---------------------------------------------------------------------*/
clear(x1,y1,x2,y2)
int x1,y1,x2,y2;
{
setfillstyle(1,0);
setcolor(0);
bar(x1,y1,x2,y2);
}


play_music()
{
FILE *f;
char buf[2000];
f=fopen("intro.dat","rb");fread(buf,1,634,f);fcloseall();
play(buf,2);
}


/*---------------------- draw () --------------------------------------*\
| This function draws a picture which is divided into many lines with   |
| coordinates stored in the array argument with length in the argument  |
| size. The x and y scales must be sent in the global vaariables ratiox |
| and ratioy . The origin point x,y coordinates is stored in the global |
| variables positionx and position y .                                  |
| In this function if the coordinates are +ve a line is drawn from the  |
| current position to the point and if the coordinates are -ve the      |
| current position is changed to the coordinates without drawing , this |
| helps in drawing the non-continuous pictures .                        |
|       IN: array: array of coordinates of the points                   |
|           size: size of the array                                     |
|       OUT: NONE                                                       |
\*---------------------------------------------------------------------*/
draw(array,size)
int array[],size;
{
int count,x,y;

for (count=0;count<=size;count+=2)              /* for each point */
{
float result;
if ( (array[count]<0) && (array[count+1]< 0) )
{       /* if negative coordinaes , then move without drawing */
x=positionx+floor((-array[count])*ratiox);      /* calculate x-ccord. */
y=positiony+floor((-array[count+1])*ratioy);    /* calculate y-coord. */
moveto(x,y);}                                   /* move to there */

else                                    /* otherwise, draw */
   {
   x=positionx+floor(array[count]*ratiox);      /* calculate x-coord. */
   y=positiony+floor(array[count+1]*ratioy);    /* calculate y-coord. */
   lineto(x,y);}                                /* draw a line */
   }
}

/*---------------------- flags () -------------------------------------*\
| This function draws the flags of the specified country . I noticed    |
| that the arabian flags have many common features such as having stars |
| and cresents so I wrote some functions that are used all over the     |
| arabian flags and these functions are triangle(), v_cresent(),        |
| h_cresent(), draw_star() and as for the exceptions such as the flags  |
| of Saudi arabia I draw the flag using the draw() function with the    |
| suitable data .                                                       |
|       IN: country: the country's no. of which the flag will be drawn  |
|           x,y: x,y coordinates of the place where the flag will be    |
|                drawn                                                  |
|       OUT: NONE                                                       |
\*---------------------------------------------------------------------*/
flags(country,x,y)
int country,x,y;
{
int cnt;

setlinestyle(0,1,1);
clear(x,y,x+180,y+90);                  /* clear flag's portion on screen */
setcolor(15);rectangle(x,y,x+180,y+90); /* draw frame of flag */
switch(country)
	{               /* which country do you want its flag? */
	case 1: setcolor(14);
		rectangle(x,y,x+180,y+90);
		draw_star(x+80,y+25,14,14);
		h_cresent(x+80,y+25,14);
		setfillstyle(1,GREEN);floodfill(x+1,y+1,14);
		break;
	case 3:
		v_cresent(x+90,y+30,RED,RED);
		draw_star(x+90,y+36,RED,RED);
		putpixel(x+91,y+31,RED);
		putpixel(x+91,x+63,RED);
		line(x+90,y,x+90,y+90);
		rectangle(x,y,x+180,y+90);
		setfillstyle(1,GREEN);floodfill(x+2,y+3,RED);setcolor(GREEN);
		floodfill(x+89,y+40,RED);setfillstyle(1,15);floodfill(x+91,y+2,RED);
		line(x+90,y,x+90,y+29);line(x+90,y+65,x+90,y+90);line(x+90,y+34,x+90,y+58);
		break;
	case 4:
		setcolor(RED);
		rectangle(x,y,x+180,y+90);
		v_cresent(x+87,y+30,RED,RED);
		draw_star(x+87,y+36,RED,RED);
		circle(x+91,y+47,30);
		setfillstyle(1,RED);floodfill(x+1,y+1,RED);
		setfillstyle(1,15);floodfill(x+84,y+50,RED);
		break;
	case 8:
		setcolor(15);
		rectangle(x,y,x+180,y+90);
		triangle(x,y,15,15);
		line(x,y+45,x+180,y+45);
		setfillstyle(1,GREEN);floodfill(x+50,y+1,15);
		setfillstyle(1,BLUE);floodfill(x+50,y+50,15);
		draw_star(x+10,y+36,RED,RED);
		break;
	case 11:
		triangle(x,y,RED,15);
		line(x+39,y+30,x+180,y+30);
		line(x+39,y+60,x+180,y+60);
		setfillstyle(1,0);floodfill(x+20,y+1,15);
		setfillstyle(1,WHITE);floodfill(x+80,y+32,15);
		setfillstyle(1,GREEN);floodfill(x+40,y+61,15);
		break;
	case 13:
		line(x,y+30,x+180,y+30);
		line(x,y+60,x+180,y+60);
		setfillstyle(1,RED);floodfill(x+1,y+1,15);
		setfillstyle(1,BLACK);floodfill(x+1,y+61,15);
		setfillstyle(1,15);floodfill(x+1,y+31,15);
		draw_star(x+50,y+32,GREEN,GREEN);
		draw_star(x+103,y+32,GREEN,GREEN);
		break;
	case 14:
		triangle(x,y,RED,15);
		draw_star(x+10,y+36,15,15);
		line(x+39,y+30,x+180,y+30);
		line(x+39,y+60,x+180,y+60);
		setfillstyle(1,0);floodfill(x+50,y+1,15);
		setfillstyle(1,15);floodfill(x+70,y+31,15);
		setfillstyle(1,GREEN);floodfill(x+70,y+61,15);
		break;
	case 17:
		for(cnt=0;cnt<=8;cnt++)
			{
			line(x+60,y+(10*cnt),x+50,y+5+(10*cnt));
			line(x+50,y+5+(10*cnt),x+60,y+10+(10*cnt));
			}
		setfillstyle(1,15);floodfill(x+1,y+1,15);
		setfillstyle(1,RED);floodfill(x+70,y+8,15);
		break;
	}
setcolor(0);rectangle(x,y,x+180,y+90);  /* make frame black */
}

/*---------------------- draw_star () ---------------------------------*\
| This function draws a star at the specified position on screen with   |
| the specified border color. The filling color is passed to it.        |
|       IN  : x,y: coordinates of star,                                 |
|             color: filling color,                                     |
|             border: border color.                                     |
|       OUT : NONE.                                                     |
\*---------------------------------------------------------------------*/
draw_star(x,y,color,border)
int x,y,color,border;
{
setcolor(border);
line(x,y+6,x+24,y+6);line(x+24,y+6,x+6,y+18);line(x+6,y+18,x+12,y);
line(x+12,y,x+18,y+18);line(x+18,y+18,x,y+6);   /* draw outline */
setfillstyle(1,color);
floodfill(x+12,y+4,border);floodfill(x+3,y+7,border);floodfill(x+20,y+7,border);
floodfill(x+12,y+7,border);floodfill(x+8,y+16,border);floodfill(x+16,y+16,border);
							/* fill the star */
}

/*---------------------- h_cresent () ---------------------------------*\
| This function draws a horizontal cresent on the screen.               |
|       IN  : x,y : coordinates of cresent,                             |
|             color : its color.                                        |
|       OUT : NONE.                                                     |
\*---------------------------------------------------------------------*/
h_cresent(x,y,color)
int x,y,color;
{
setcolor(color);
arc(x+11,y+10,180,360,23);
arc(x+11,y+16,170,370,23);
floodfill(x+10,y+30,color);
}

/*---------------------- v_cresent () ---------------------------------*\
| This function draws a vertical cresent on the screen.                 |
|       IN  : x,y : coordinates of cresent,                             |
|             color : its color.                                        |
|       OUT : NONE.                                                     |
\*---------------------------------------------------------------------*/
v_cresent(x,y,color)
int x,y,color;
{
setcolor(color);
arc(x+11,y+17,90,270,23);
arc(x+5,y+17,80,280,23);
setfillstyle(1,color);
floodfill(x-14,y+18,color);
}

/*---------------------- triangle () ----------------------------------*\
| This function draws a triangle on the screen with specified color and |
| border. The location is passed to the function.                       |
|       IN  : x,y : coordinates of triangle,                            |
|             color : its color.                                        |
|             border: border's color.                                   |
|       OUT : NONE.                                                     |
\*---------------------------------------------------------------------*/
triangle(x,y,color,border)
int x,y,color,border;
{
setcolor(border);
line(x,y,x,y+90);               /* draw outline */
line(x,y,x+60,y+45);
line(x+60,y+45,x,y+90);
setfillstyle(1,color);
floodfill(x+3,y+10,border);     /* fill the triangle */
}
/***********************************************************************\
|       E N D   O F   A L A M U N A . C   S O U R C E   C O D E         |
\***********************************************************************/

