int letters[17835],posi,init16,init2;

/*---------------------- arabic_text () -------------------------------*\
| This function displayes an Arabic string on the specified loaction on |
| the screen.                                                           |
| If it is called for the first time, it loads letters from disk.       |
\*---------------------------------------------------------------------*/
arabic_text(buf,x,y,colu,put)
char buf[100];
int x,y,colu,put;
{
#define pulling (buf[cnt+1])
#define cntdec (buf[cnt-1])
#define posin (letterno*(posi*4))
#define lenbuf (strlen(buf))
#define resetall (letterno=offset=pulled=0);

int cnt,letterno,offset,cnt3,pulled,caseno,oldx;
char pull[]={'f','j','e','\x5B','p','o','s','a','w','q','\x27','\x2F','u',
	     'y','t','r','\x3B','g','l','k','i','d','z','\0','J'};
char letkey[]={'h','f','j','e','\x5B','p','o','\x5D','\x60','v','\x2E','s',
	      'a','w','q','\x27','\x2F','u','y','t','r','\x3B','g','l','k',
	      'i','\x2C','d','c','z','\x3E','\x3A','m','x','1','2','3','4',
	      '5','6','7','8','9','0','N','H','G','B','b','Y','T',' ','J'};
setcolor(15);setfillstyle(SOLID_FILL,15);       /* display preparation */
cnt=letterno=offset=pulled=0;                 /* Resets the counters to zero */
if ((init16!=1) && (colu==0))           /* If this is the first call */                    
   initia16();                          /* then initialize */
if ((init2!=1) && (colu==1))    /* If initialization isn't done, do it */
   initia2();

while (cnt<=lenbuf-1)
{
/* locates the position of the letter being processed in the letkey array
   which is the set of all letters the position is recorded in letterno  */

	while (buf[cnt]!=letkey[letterno]) 
		{ /*while not at the write entry increase the variable letterno*/
		letterno++;
		}

/* Compares the letter before the letter before the letter being checked 
   to the set of pulling letters and if it matches any the variable pulled 
   is switched on to 1 else it is switched to 0                         */

if ( (lenbuf!=1) && (cnt!=0) )
   {
   for (cnt3=0;cnt3<=24;cnt3++)
      {
      if (cntdec==pull[cnt3])
	 pulled=1;                      /* set the pulling flag */
      }
   }

/* The next statments checks the letter's figure and calculates the start
   address in the array letters[]. the address is stored in caseno   */

if (lenbuf !=1)         /* if not a single-character buffer */
   if (((cnt==0) && (pulling!=' '))      /* If this the 1st letter and the 
					   next letter isn'e a space */
       || ((cnt!=0) && (cntdec==' ') && (pulling!=' ')) /* or if not 1st letter 
		and is preceeded by a space while not followed by a space */
       || ((cnt!=0) && (pulled!=1) && (pulling!=' ')))   /* or if not 1st letter
		and next character isn't a space and pulling flag is set */
      {
      caseno=posi*1;
      }

if (lenbuf!=1)          /* If not a single-character buffer */
   {
   if (  ((pulling==' ') && (cntdec==' '))       /* if both characters after 
					and before this character are spaces */
       || ((cntdec==' ') && (cnt==lenbuf-1))    /* or if this is the last 
				  character and the one before it is a space */
       || ((cnt==lenbuf-1) && (cntdec==' '))    
       || ((pulling==' ') && (pulled!=1))        /* or if next character is a space
							and no pulling exists */
       || ((cnt==lenbuf-1) && (pulled!=1)) )    /* or if last char & pulling */
      caseno=0;
   }
else
   {
   if (buf[0]!=' ')                     /* if first character is a space */
   caseno=0;
   }


if (lenbuf!=1)                  /* if not a single-character buffer */
   if ( ((cnt!=0) && (pulling==' ') && (pulled==1)) /* if not the first character 
				but pulling exists and next char is a space */
       || ((cnt==lenbuf-1) && (pulled==1) && (cnt!=0)) )
				/* or if not 1st character with pulling but 
				last character */
      {
      caseno=posi*3;
      }

if (lenbuf!=1)                  /* if not a single-character buffer */
   if ( (pulling!=' ') && (pulled==1) && (cnt!=lenbuf-1))
      { /* if next character isn't space and not the last char. & pulling */
      caseno=posi*2;
      }

offset=(posin)+caseno; /*offset equals the no in array of letkey multiplied by 87 
	  to achieve the entry at which the letter begins in array letters. 
	  Remember that each character resides in 87 bytes.             */

	/* If the letter isn't space put the letter on the screen. This is
	   done to avoid putting the unknown data in the memory*/
	if (buf[cnt]==' ') x-=13;       /* SPACE:just decrement x-coord */
	
	if (buf[cnt]=='J') /* Case of the connecting Arabic character "_" */
	   {putimage(x,y,&letters[17748],put);x-=13;}
	
	if(buf[cnt]!=' ' && buf[cnt]!='J')      /* any other letter */
	   {putimage(x,y,&letters[offset],put);x-=13;}
	resetall                     /* initialize counters for next letter */
	cnt++;                          /* next letter in buffer */


} /*close of the while*/
cnt=0;
}       /*close of the arabic_text function*/

/*--------------------  initia16 () -----------------------------------*\
| This function opens the "usedfont.dat" file for letters data and loads|
| it into the array letters[]                                           |
\*---------------------------------------------------------------------*/
initia16()
{
FILE *fptr;
fptr=fopen("usedfont.dat","rb");            /* open the file */
fread(letters,2,17835,fptr);            /* read its contents into letters[] */
fclose(fptr);                           /* an close the file */
/*switchs on to avoid the reinitializing if the function is executed again*/
init16=1;init2=0;posi=87;
}

/*--------------------  initia2 () ------------------------------------*\
| This function opens the "letdata.02c" file for letters data and loads |
| it into the array letters[]                                           |
\*---------------------------------------------------------------------*/
initia2()
{
FILE *fptr;
fptr=fopen("lets.bin","rb");            /* open the file */
fread(letters,2,4896,fptr);             /* read its contents */
fclose(fptr);                           /* and then close it -*
/* switchs on to avoid the reinitializing if the function is executed again */
init2=1;
init16=0;
posi=24;
}
