#include <graphics.h>
#include <stdio.h>
#include "fcntl.h"
#include "\tc\include\sys\stat.h"
#include "arabic.c"
#include <math.h>
#include <conio.h>
#define beep printf("\x7")
#define display_line arabic_text(st,editx,edity,0,1)
#define UP 72
#define DOWN 80
#define LEFT 75
#define RIGHT 77
int yn,buffer[2048],row=1;
int markerx=0,markery=0;
char st[49],lesson_name[12][20],file_name[12][13];
char letkey[]={'h','f','j','e','\x5B','p','o','\x5D','\x60','v','\x2E','s',
	      'a','w','q','\x27','\x2F','u','y','t','r','\x3B','g','l','k',
	      'i','\x2C','d','c','z','\x3E','\x3A','m','x','1','2','3','4',
	      '5','6','7','8','9','0','N','H','G','B','b',
	      '\x20','\x0D','\x08','Y','T','\x1B',' '};
FILE *hdrptr,*bodyptr;/*file pointers to the header and the body files*/

int lessons_no;
main()
{
while(1)
{fcloseall();
main_menu();}
}

main_menu()
{
int end=0,choice=0;
char ch;
initialize_graph();
setcolor(15);
rectangle(1,8,630,33);setfillstyle(SOLID_FILL,RED);floodfill(2,9,WHITE);
rectangle(1,33,476,290);setfillstyle(SOLID_FILL,YELLOW);floodfill(2,34,WHITE);
rectangle(476,33,630,290);setfillstyle(SOLID_FILL,BLUE);floodfill(477,34,WHITE);
line(1,100,630,100);
arabic_text("lu]  ]v,s  hgjhvdo",410,10,0,1);
arabic_text("wtpJJJJhj",610,50,0,1);
arabic_text("]  v ,  s",610,103,0,1);
getimage(500,50,624,70,buffer);
putimage(500,50,buffer,NOT_PUT);
arabic_text("dl;k; i`h hTojdhv lk Yqhtm H,",450,50,0,1);
arabic_text("Ygyhx wtpm td lgt ]vs >",450,71,0,1);
arabic_text("dl;k; i`h hTojdhv lk jp]d] Hslhx",450,103,0,1);
arabic_text("hglgthj hgjd sdjuhlg luih hgfvkhl[",450,124,0,1);
arabic_text(", jp]d] Hslhx hg]v,s hgjd jpj,dih",450,145,0,1);
arabic_text("hglgthj ,d;,k `g; fYqhtm H, Ygyhx",450,166,0,1);
arabic_text("Hslhx hg]v,s , hglgthj grhzlm",450,187,0,1);
arabic_text("hg]v,s , hglgthj hgjd sdjuhlg luih",450,208,0,1);
arabic_text("hgfvkhl[ >",450,229,0,1);
arabic_text("hsjo]l hGsil ,      gTojdhv ,     ggov,[",575,305,0,1);
outtextxy(160,310,"ESC                    ENTER");
while(end!=1)
{
ch=getch();
if(ch==0)
choice=menu(500,50,124,21,1,choice,getch(),33);
else
	switch(ch)
		{
		case 13:
			if(choice==0){cleardevice();pages_system();end=1;break;}
			if(choice==1){lessons_system();end=1;break;}
		case 27:
			beep;textmode(C80);exit(0);
		default:
			beep;
		}
}
}



lessons_system()
{
int end=0;
cleardevice();
get_page_info();
while(end!=1)
	{
	switch(get_choice())
		{
		case 0: add();break;
		case 1: del_ete();break;
		case 2: save_page();break;
		case 3: end=1;continue;
		}
	cleardevice();
	show_page_info();
	}
}

get_page_info()
{
load_page_info();
show_page_info();
}

show_page_info()
{
int cntr;
setcolor(WHITE);setfillstyle(SOLID_FILL,LIGHTBLUE);
rectangle(1,1,635,23);settextstyle(SANS_SERIF_FONT,0,1);
floodfill(3,3,WHITE);
arabic_text("hgvrl  hsl hg]vs                 hsl hglgt",620,2,0,1);
setcolor(15);
line(229,1,229,303);
line(539,1,539,303);
for(cntr=0;cntr<=11;cntr++)
	{
	rectangle(2,29+(23*cntr),635,51+(23*cntr));
	setfillstyle(SOLID_FILL,BLUE);
	floodfill(4,33+(23*cntr),15);
	setfillstyle(SOLID_FILL,RED);
	floodfill(232,33+(23*cntr),15);
	setfillstyle(SOLID_FILL,GREEN);
	floodfill(542,33+(23*cntr),15);
	}


for(cntr=0;cntr<=lessons_no-1;cntr++)
	{
	outtextxy(85,30+(23*cntr),&file_name[cntr][0]);
	arabic_text(&lesson_name[cntr][0],525,30+(23*cntr),0,1);
	st[0]=49+cntr;st[1]='\x0';
	if(cntr==9) strcpy(st,"01");
	if(cntr==10) strcpy(st,"11");
	if(cntr==11) strcpy(st,"21");
	arabic_text(st,595,30+(23*cntr),0,1);
	}
}

load_page_info()
{
FILE *fpt;
int cntr;
if((fpt=fopen("lesson.sav","r"))==NULL)
	file_error("lesson.sav");
fscanf(fpt,"%d",&lessons_no);
if(lessons_no!=0)
	for(cntr=0;cntr<=lessons_no-1;cntr++)
		{
		fread(&lesson_name[cntr][0],1,20,fpt);
		fread(&file_name[cntr][0],1,13,fpt);
		}
fclose(fpt);
}

get_choice()
{
char ch;
int choice=0,end=0;
arabic_text("Yqhtm ]vs",450,310,0,1);
arabic_text("Ygyhx ]vs",450,331,0,1);
arabic_text("pt/ hg]v,s",250,310,0,1);
arabic_text("ov,[",250,331,0,1);
getimage(300,310,470,330,buffer);
putimage(300,310,buffer,NOT_PUT);
while(end!=1)
	{
	ch=getch();
	if(ch==0)
		choice=double_menu(300,310,100,310,170,21,1,choice,getch());
	else
		switch(ch)
			{
			case 13:/*if enter check the return values*/
				if(row==2) choice+=2;
				end=1;
				break;
			case 27:/*if ESC return as if the choice is 3*/
				choice=3;end=1;break;
			default:
				beep;
				break;
			}
	}
row=1;
return(choice);
}

add()
{
clear(1,308,630,350);
setcolor(WHITE);setfillstyle(SOLID_FILL,YELLOW);
rectangle(1,309,635,350);rectangle(2,310,634,349);floodfill(3,312,WHITE);
if(lessons_no<=11)
	{
	setcolor(LIGHTGRAY);rectangle(79,310,313,331);setfillstyle(SOLID_FILL,LIGHTGRAY);
	floodfill(81,312,LIGHTGRAY);setcolor(LIGHTGRAY);rectangle(80,334,313,348);floodfill(81,337,LIGHTGRAY);
	}

if(lessons_no>=12)
	{
	putch('\x7');
	arabic_text("[ldu hg]v,s lay,gm >>> b dl;kkd i`h",620,310,0,1);
	arabic_text("Yqy' Hd ltjhp gTsjlvhv",620,331,0,1);
	getch();
	}
else
	{
	arabic_text("Ysl hg]vs  :",520,310,0,1);
	arabic_text("Ysl hglgt  :",520,331,0,1);
	edit_line(300,310,18);
	strcpy(&lesson_name[lessons_no][0],st);
	english_edit(97,344,8,LIGHTGRAY);
	strcpy(&file_name[lessons_no][0],st);
	lessons_no+=1;
	}
}


del_ete()
{
int les=0,cntr=0,cnt=0;
int choice=0,end=0;
char ch;
clear(1,308,630,350);
getimage(230,30,538,50,buffer);
putimage(230,30,buffer,NOT_PUT);
if(lessons_no==0)
		{
		arabic_text("[ldu hg]v,s ohgdm hBk >>> b dl;k i`h",620,310,0,1);
		arabic_text("Yqy' Hd ltjhp gTsjlvhv >",620,331,0,1);
		getch();
		}
else
{
arabic_text("Ysjo]l hGsil gTojdhv el hqy' hT]ohg gTgyhx",580,310,0,1);
while(end!=1)
	{
	ch=getch();
	if(ch==0)
		choice=menu(230,30,308,21,lessons_no-1,choice,getch(),2);
	else
		switch(ch)
			{
			case 13:end=1;break;
			default:beep;break;
			}
	}
}
if(lessons_no!=0)
	{
	les=choice;
	lessons_no-=1;
	for(cntr=les;cntr<=lessons_no-1;cntr++)
		{
		for(cnt=0;cnt<=20;cnt++)
		lesson_name[cntr][cnt]=lesson_name[cntr+1][cnt];

		for(cnt=0;cnt<=13;cnt++)
		file_name[cntr][cnt]=file_name[cntr+1][cnt];
		}
	}
}

save_page()
{
int cntr;
FILE *fpt;
if((fpt=fopen("lesson.sav","w"))==NULL)
	file_error("lesson.sav");
fprintf(fpt,"%d",lessons_no);
if(lessons_no!=0)
	{
	for(cntr=0;cntr<=lessons_no-1;cntr++)
		{
		fwrite(&lesson_name[cntr][0],1,20,fpt);
		fwrite(&file_name[cntr][0],1,13,fpt);
		}
	}
fclose(fpt);
}
pages_system()
{
int choice=0,end=0;
char ch;
rectangle(1,1,638,290);
rectangle(2,2,637,290);
line(0,160,638,160);
line(476,1,476,290);
arabic_text(";jhfm wtpm",620,5,0,1);
arabic_text("Ygyhx wtpm",620,165,0,1);
arabic_text("dl;k; i`h hTojdhv lk ;jhfm wtpm td",450,5,0,1);
arabic_text("]vs , d;,k `g; uk 'vdr hg;jhfm td",450,26,0,1);
arabic_text("lgt hg]vs > td hgf]hdm ugd; Hk",450,47,0,1);
arabic_text("hsl hglgt el uk,hk hgwtpm el Hk",450,68,0,1);
arabic_text("j;jf hgwtpm el jp]] l;hk ,r,u",450,89,0,1);
arabic_text("hgp]e hg`d jpj,di hgwtpm ugd",450,110,0,1);
arabic_text("hgovd'm >",450,131,0,1);

arabic_text("dl;k; i`h hTojdhv lk Ygyhx wtpm",450,165,0,1);
arabic_text("lk lgt ]vs > ugd; H,b Hk j]og",450,186,0,1);
arabic_text("hsl hglgt el Hk jojhv hsl hgwtpm",450,207,0,1);
arabic_text("hgjd jvd] hgyhzih >",450,228,0,1);
arabic_text("hsjo]l hGsil ,      gTojdhv ,     ggov,[",575,305,0,1);
outtextxy(160,310,"ESC                    ENTER");
getimage(490,5,632,25,buffer);
putimage(490,5,buffer,NOT_PUT);
while(end!=1)
	{
	ch=getch();
	if(ch==0)
		choice=menu(490,5,142,21,1,choice,getch(),139);
	else
		switch(ch)
			{
			case 13:
				if(choice==0) {get_page();end=1;}
				if(choice==1) {delete_page();end=1;}
				break;
			case 27:
				end=1;
				break;
			}
	}
}

delete_page()
{
int pages_no,cntr,markerx,markery,size,end=0,choice=0;
char filename[16],title[23],ch;
cleardevice();
arabic_text("H]og Ysl hglgt",630,40,0,1);
english_edit(300,40,8,BLACK);
size=strlen(st);
strcpy(filename,st);
cleardevice();
pages_no=delete_open_show(filename,size);
strcpy(&filename[size],".bdy");
getimage(201,30,464,50,buffer);
putimage(201,30,buffer,NOT_PUT);
if (pages_no==0)
	{gotoxy(10,10);printf("There is no pages to operate");
	gotoxy(10,12);printf("Press any key to continue ...");
	if(getch()==0) getch();
	execl("lessprep.exe",0);
	exit(2);}
while(end!=1)
	{
	ch=getch();
	if(ch==0)
		choice=menu(201,30,464-201,21,pages_no-1,choice,getch(),2);
	else
		switch(ch)
		{
		case 13: fcloseall();delete_page1(choice);end=1;break;
		case 27: fcloseall();end=1;break;
		}
	}

}

delete_open_show(filename,size)
char filename[14];
int size;
{
FILE *hdrptr;
int cntr,pages_no,markx,marky;
char title[30];
strcpy(&filename[size],".hdr");
if((hdrptr=fopen(filename,"r"))==NULL)
	file_error(filename);
strcpy(&filename[size],'\x0');
for(cntr=0;cntr<=11;cntr++)
	{
	rectangle(200,29+(23*cntr),465,51+(23*cntr));
	setfillstyle(SOLID_FILL,YELLOW);
	floodfill(201,33+(23*cntr),15);
	}
fscanf(hdrptr," %d ",&pages_no);
for(cntr=0;cntr<=pages_no-1;cntr++)
	{
	fread(title,1,20,hdrptr);
	fscanf(hdrptr," %d %d ",&markx,&marky);
	arabic_text(title,450,30+(23*cntr),0,1);
	}
return(pages_no);
}

delete_page1(choice)
int choice;
{
int size,cntr,pages_no,markx,marky,term=0;
FILE *hdrptr,*bdyptr,*tempptr;
char title[31];
size=strlen(st);
strcpy(&st[size],".hdr");
if((hdrptr=fopen(st,"r"))==NULL)
	file_error(st);
if((tempptr=fopen("temp.tmp","w"))==NULL)
	file_error("temp.tmp");
fscanf(hdrptr," %d ",&pages_no);
if (pages_no==0)
	{gotoxy(10,10);printf("There is no pages to operate");
	gotoxy(10,12);printf("Press any key to continue ...");
	if(getch()==0) getch();
	execl("lessprep.exe",0);
	exit(2);}
fprintf(tempptr," %d ",pages_no-1);
for(cntr=0;cntr<=choice-1;cntr++)
	{
	fread(title,1,20,hdrptr);
	fwrite(title,1,20,tempptr);
	fscanf(hdrptr," %d %d ",&markx,&marky);
	fprintf(tempptr," %d %d ",markx,marky);
	}
fread(title,1,20,hdrptr);
fscanf(hdrptr," %d %d ",&markx,&marky);
for(cntr=choice+1;cntr<=pages_no-1;cntr++)
	{
	fread(title,1,20,hdrptr);
	fwrite(title,1,20,tempptr);
	fscanf(hdrptr," %d %d ",&markx,&marky);
	fprintf(tempptr," %d %d ",markx,marky);
	}
fcloseall();
unlink(st);
copy("temp.tmp",st);
strcpy(&st[size],".bdy");
if((bdyptr=fopen(st,"rb"))==NULL)
	file_error(st);
if((tempptr=fopen("temp.tmp","wb"))==NULL)
	file_error("temp.tmp");
for(cntr=0;cntr<=choice-1;cntr++)
	{
	while(term!=1)
		{
		fread(title,1,31,bdyptr);
		fwrite(title,1,31,tempptr);
		if (title[1]=='\x0') term=1;
		}
	term=0;
	}
term=0;
while(term!=1)
	{
	fread(title,1,31,bdyptr);
	if(title[1]=='\x0') term=1;
	}
term=0;
for(cntr=choice;cntr<=pages_no-2;cntr++)
	{
	while(term!=1)
		{
		fread(title,1,31,bdyptr);
		fwrite(title,1,31,tempptr);
		if (title[1]=='\x0') term=1;
		}
	term=0;
	}
fcloseall();
unlink(st);
copy("temp.tmp",st);
strcpy(&st[size],'\x0');
}

char fname[15];
get_page()
{
char ch;
get_open_file();                                        /*get and open the file*/
arabic_text("hguk,hk        :",600,121,0,1);
edit_line(385,121,19);                                  /*get the page title*/
fwrite(st,1,20,hdrptr);fwrite(st,1,31,bodyptr);         /*write it to both header and body files*/
cleardevice();                                          /*clear screen*/
arabic_text("hgwtpm:",620,10,0,1);
arabic_text("JJJJJJJ",620,20,0,1);
arabic_text("fu] kihdm ;g",620,90,0,1);
arabic_text("s'v hqy'",620,110,0,1);
outtextxy(480,115,"ENTER");
arabic_text(", fu] kihdJm",620,130,0,1);
arabic_text("hgwtpm hqyJ'",620,150,0,1);
outtextxy(580,175,".  ESC");
edit_page();                                            /*get the lesson body and write it to the body file*/
cleardevice();                                          /*clear screen*/
draw_map();                                             /*draw the map*/
arabic_text("hsjo]l hGsil gjpvd; hglcav el hqy'",520,170,0,1);
outtextxy(490,200,"ESC");
arabic_text("gTojdhv , hgu,]m ggrhzlm",468,195,0,1);
arabic_text("hgvzdsdm >",520,220,0,1);
mover();                                                /*display the marker and get the coordinates of the marker in markerx and markery*/
fprintf(hdrptr," %d %d ",markerx,markery);              /*write the coordinates to the header file*/
fcloseall();                                            /*close all files*/
update_header_file(fname);                              /*update the pages no in the header file and write the updated file into "temp.tmp"*/
copy("temp.tmp",fname);                                 /*copy "temp.tmp" on "the header file"*/
}

update_header_file(filename)
char filename[16];
{
FILE *iptr,*optr;
int pages_no,cntr,markx,marky;
char title[21];
if((iptr=fopen(filename,"r"))==NULL)
	{printf("Can't open file \"%s\"",filename);exit(1);}
if((optr=fopen("temp.tmp","w"))==NULL)
	{printf("Can't open file \"temp.tmp\"");exit(1);}
fscanf(iptr," %d ",&pages_no);
fprintf(optr," %d ",pages_no+1);
for(cntr=0;cntr<=pages_no;cntr++)
	{
	fread(title,1,20,iptr);
	fwrite(title,1,20,optr);
	fscanf(iptr," %d %d ",&markx,&marky);
	fprintf(optr," %d %d ",markx,marky);
	}
fcloseall();
}

edit_page()
{
char ch;
int y=-10,key_pressed;
y+=20;
while(y<=330)
{
key_pressed=edit_line(390,y,30);
switch(key_pressed)
	{
	case 27:
		write_file();
		zero_string();
		fwrite(st,1,31,bodyptr);
		y=400;break;
	case 13:
		write_file();
		y+=21;
		break;
	}

}/*1st while*/
fclose(bodyptr);
}/*function*/

edit_line(editx,edity,maxchrs)
int editx,edity,maxchrs;
{
int lineend=0,i=0,returnvalue;
char ch;
zero_string();
while(lineend!=1)
{
ch=getch();
if ((i==maxchrs) && (ch!='\x8') && (ch!='\x0D'))
{beep;continue;}
if (check_letter(ch)==1)
	{
	switch (ch)
		{
		case 8:
			if (i==0) beep;
			else
			{
				display_line;
				i--;
				st[i]='\x0';
				display_line;
			}
			break;
		case 13:
			lineend=1;
			returnvalue=13;
			break;
		case 27:
			lineend=1;
			returnvalue=27;
			break;
		default:
			if (i!=0)
			display_line;
			st[i]=ch;
			i++;
			display_line;
		}

	}
else beep; /*else for (check_letter) check*/
} /*while*/
lineend=0;
return(returnvalue);
} /*function*/

english_edit(editx,edity,maxchrs,backcolor)
int editx,edity,maxchrs,backcolor;
{
int end=0,i;
char ch;
editx=ceil(editx/9.0);edity=ceil(edity/14.0);
gotoxy(editx,edity);
for(i=0;i<=maxchrs;i++) {gotoxy(editx+i,edity);printf(" ");}
i=0;
zero_string();
while(end!=1)
	{
	ch=getch();
	switch(ch)
		{
		case 0: getch();putch(7);break;
		case 27: end=1;exit(0);break;
		case 13: end=1;break;
		case 8: if(i!=0)
				{editx-=1;gotoxy(editx,edity);printf("  ");i--;
				st[i]=0;
				}
			else putch(7);
			break;
		default:
			if(check_english_letter(ch)==1)
				{
				if(i<maxchrs) {gotoxy(editx,edity);printf("%c",ch);editx+=1;st[i]=ch;i++;}
				else putch(7);
				}
			else putch(7);
			break;
		}
	}
}

file_error(filename)
char *filename;
{
gotoxy(20,10);printf("Can't open file %s",filename);
gotoxy(20,12);printf("Press any key to continue ...");
if(getch()==0) getch();
execl("lessprep.exe",0);
exit(2);
}


check_english_letter(ch)
char ch;
{
char permit[]={'a','b','c','d','e','f','g','h','i','j','k','l','m','n','o',
'p','q','r','s','t','u','v','w','x','y','z','A','B','C','D','E','F','G','H',
'I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z','1',
'2','3','4','5','6','7','8','9','0','-','_','='};
int i,returnvalue=0;
for(i=0;i<=sizeof(permit)-1;i++)
	if(ch==permit[i]) returnvalue=1;
return(returnvalue);
}


menglish_edit(editx,edity,maxchrs,backcolor)
int editx,edity,maxchrs,backcolor;
{
#define display_string moveto(editx,edity);outtext(st)
int lineend=0,i=0,returnvalue,color;
char ch;
edity+=6;
zero_string();
settextstyle(DEFAULT_FONT,0,1);
while(lineend!=1)
{
ch=getch();
if ((i==maxchrs) && (ch!='\x8') && (ch!='\x0D'))
{beep;continue;}
	switch (ch)
		{
		case 8:
			if (i==0) beep;
			else
			{
				setfillstyle(SOLID_FILL,backcolor);
				color=getcolor();
				setcolor(backcolor);
				bar(editx,edity,editx+(maxchrs*12),edity+10);
				setcolor(color);
				i--;
				st[i]='\x0';
				display_string;
				putch(' ');
			}
			break;
		case 13:
			lineend=1;
			returnvalue=13;
			break;
		case 27:
			lineend=1;
			returnvalue=27;
			break;
		default:
			/*if (i!=0)*/
			st[i]=ch;
			i++;
			display_string;
		}
} /*while*/
lineend=0;
return(returnvalue);
} /*function*/




end()
{
fcloseall();
exit(0);
}

get_open_file()
{
int size;
char filename[16];
setfillstyle(SOLID_FILL,YELLOW);floodfill(0,0,YELLOW);setcolor(0);
arabic_text("H]og Ysl hglgt :",600,100,0,1);
english_edit(150,100,8,YELLOW);
strcpy(filename,st);
size=strlen(filename);
strcpy(&filename[size],".hdr");
write_header_file(filename);                             /*if there is no file begin a new one*/
if((hdrptr=fopen(filename,"a"))==NULL) /*open the header file*/
	file_error(filename);
strcpy(&filename[size],".bdy");
if ((bodyptr=fopen(filename,"ab"))==NULL)                       /*open the body file*/
	file_error(filename);
strcpy(&filename[size],".hdr");
strcpy(fname,filename);
setcolor(15);
}


write_header_file(filename)
char filename[16];
{
FILE *fptr;
int pages_no,cntr,markx,marky;
if ((fptr=fopen(filename,"r"))==NULL)                           /*file doesn't exist*/
	 {
	 fclose(fptr);                                          /*close it*/
	 if ((fptr=fopen(filename,"w"))==NULL)                  /*reopen for writing*/
		file_error(filename);
	 fprintf(fptr," %d ",0);                                /*write initial pages no which is 0*/
	 fclose(fptr);                                          /*close file*/
	 }
fclose(fptr);                                                   /*close file if exists*/
}




check_letter(ch)
char ch;
{
int chc,foundyn=0;
for(chc=0;chc<=55;chc++)
{if(ch==letkey[chc])
foundyn=1;}
return(foundyn);
}

zero_string()
{
int f;
for (f=0;f<=31;f++)
st[f]='\x0';
}

write_file()
{
if(st[1]=='\x0') strcpy(&st[0],"     ");
fwrite(st,1,31,bodyptr);
}

initialize_graph()
{
int gdriver=EGA,gmode=EGAHI;
closegraph();
registerbgidriver(EGAVGA_driver);
initgraph(&gdriver,&gmode,"");
}

menu(xcord,ycord,width,step,itemsno,choice,excode,stepping)
int xcord,ycord,width,step,itemsno,choice,stepping;
char excode;
{
#define inverse_choice getimage(xcord,ycord+(step*choice)+(stepping*choice),xcord+width,ycord+step+(step*choice)+(stepping*choice)-1,buffer);putimage(xcord,ycord+(step*choice)+(stepping*choice),buffer,NOT_PUT)
switch(excode)
	{
	case UP:
		if (choice!=0)
			{inverse_choice;choice--;inverse_choice;}
		else
			{inverse_choice;choice=itemsno;inverse_choice;}
		break;
	case DOWN:
		if (choice!=itemsno)
			{inverse_choice;choice++;inverse_choice;}
		else
			{inverse_choice;choice=0;inverse_choice;}
		break;
	default:
		beep;
	}
return(choice);
}

double_menu(xleft1,ytop1,xleft2,ytop2,width,step,itemsno,choice,excode)
int xleft1,ytop1,xleft2,ytop2,width,step,itemsno,choice;
char excode;
{
#define row1_inverse getimage(xleft1,ytop1+(step*choice),xleft1+width,(ytop1+step-1)+(step*choice),buffer);putimage(xleft1,ytop1+(step*choice),buffer,NOT_PUT)
#define row2_inverse getimage(xleft2,ytop2+(step*choice),xleft2+width,(ytop2+step-1)+(step*choice),buffer);putimage(xleft2,ytop2+(step*choice),buffer,NOT_PUT)

int checked=0,xcord,ycord;
if (excode==RIGHT || excode==LEFT)
	{
	if(row==1)
		{row=2;row1_inverse;row2_inverse;checked=1;} /*sets checked to 1 to avoid neutralizing the effect*/
							   /*of the statement by the statement next to it*/
	if (row==2 && checked!=1)
		{row=1;row2_inverse;row1_inverse;checked=1;}
	}

if (row==1)
	{xcord=xleft1;ycord=ytop1;}
if (row==2)
	{xcord=xleft2;ycord=ytop2;}

if(checked!=1)
	choice=menu(xcord,ycord,width,step,itemsno,choice,excode,0);
else
	checked=0;

return(choice);
}

clear(left,top,right,bottom)
int left,top,right,bottom;
{
setfillstyle(1,0);
setcolor(0);
bar(left,top,right,bottom);
}

draw_map()
{
int africa[]={-91,-185,90,179,92,181,94,175,98,176,95,173,95,168,98,164,97,162,
99,157,98,156,95,156,93,150,90,148,89,150,80,147,74,138,50,147,48,147,44,145,
35,147,24,137,22,132,21,130,11,124,10,114,6,106,5,102,5,97,8,98,8,86,4,77,
5,71,18,52,21,47,21,46,35,31,37,31,40,33,46,32,50,31,51,30,55,24,56,22,61,21,
69,17,70,16,73,16,73,19,76,20,80,19,84,22,88,19,90,21,93,18,100,20,105,19,110,21,
112,19,120,22,124,20,126,22,125,24,129,23,126,27,127,31,122,36,126,37,126,40,
139,45,139,47,151,54,155,52,155,47,157,45,167,45,168,49,184,53,187,56,192,52,
198,52,195,53,207,50,208,43,211,37,210,30,207,30,205,29,204,29,200,34,192,29,
190,34,183,30,181,27,179,19,183,11,187,12,190,11,194,12,200,8,208,8,226,11,
228,5,224,1};
int europe[]={-186,-1,183,5,186,8,184,9,178,10,178,12,171,12,173,14,170,16,
169,16,167,14,165,16,173,23,171,24,167,20,166,22,170,25,165,29,161,25,162,22,
160,18,158,17,158,9,159,6,150,1,-141,-1,140,3,144,5,148,5,147,8,154,12,152,14,
148,13,145,21,143,18,146,14,138,8,135,8,132,1,-142,-22,140,24,142,25,140,28,
134,25,134,23,142,22,-128,-1,125,3,128,6,125,14,122,12,121,15,120,13,120,8,
121,7,120,5,123,3,121,1,-100,-1,94,6,95,10,90,11,90,13,85,13,83,15,79,12,
74,13,69,13,68,10,64,10,62,7,64,3,63,1};

int africa2[]={-198,-52,200,59,199,63,205,69,208,79,211,82,210,85,215,88,
216,94,216,97,220,104,222,105,223,108,228,116,233,118,235,120,244,129,241,132,
250,136,278,126,279,129,279,133,277,135,277,141,271,149,271,156,267,163,
245,185};

int asia[]={-199,-58,201,60,202,62,206,66,208,60,210,62,208,66,210,66,216,76,
216,80,219,81,224,87,225,94,228,98,231,99,240,111,240,114,241,117,244,123,
244,126,249,127,280,110,280,106,290,104,290,100,295,98,295,94,299,93,300,89,
298,88,299,85,302,86,301,81,305,77,296,72,291,73,290,72,290,68,289,65,287,65,
281,72,278,75,271,75,271,68,268,67,268,74,267,75,265,75,264,74,264,66,261,64,
260,65,257,61,257,58,254,56,260,52,265,55,265,59,267,58,271,62,282,65,284,62,
288,61,290,62,292,66,293,67,307,65,308,64,309,59,310,58,311,58};

int afcountries[]={-8,-94,16,89,28,99,32,97,35,93,38,95,47,94,49,91,51,71,
56,59,49,45,49,42,25,42,-49,-45,49,49,48,50,36,50,35,51,35,61,34,62,32,62,
31,64,30,65,28,70,27,71,5,71,-49,-42,53,40,57,37,63,39,73,38,81,35,84,32,
82,28,84,22,-56,PUT)
[','W',1411y51,35,61,34,62,32,62,95,47,94,49,91,51,71,
56,59,49,45,49,42,25,42,k,returnvrow116,76,
216,80,=fopen(filename,"w"))==NULL)                  /*reopen fI'5'	setco+(steppin7 end=1;exit(0);break;
		case 13: end=1;break;
		case 28,5,224,1};
int europe[]={-186,-1,18I
56,59,49,45,49,42,25,42,-49,-45,49,49,48,5rintf7,'F',,49,91,51,71,
break;
		case 13: end=1;break;
		case 28,5,224,1};
int eu65,55,265,59,267,58,2ttom)AULT_FONT,0,1o_string();
        etch();
exec,59,267,58,27
else
	checked(editx[,53Itch(7);
			break;
		}
	}
}

file_error(filename)
);
				scord;
if (excode== *filename;
{
gotoxy(20,10);printf("Can't open file %s",fiItch(7);
			break;
		}
	}
}

file_error(filename)name)
char filename[16];
{
F initial pages no which is 0*/
	 fclose(fptr);
execl();
else
	checked=0ak;
		}
	}
}

file_error(filename)name)
char filename[16];,233,118,235,120,244,129,241,132,
250,I59,) ssetco+(ing)
int x173,1 the body file*/
	file_error(se getimalor;
char ch;
'T',',233,118,235,120,244,129,241,132,
250,I59,','6','7','8',file_error(filename)
);
				scord;
if (excode== *filename;
{
ffer);put+;
			display_string



end()
{
fcloseall();
exit(0);
e*/
	fil6,
Iw,122,36,1lon*/




end()
{
fcloseall();
exit(0);
}

get_openver=Eit(0)ninver                                 /*close fi
chach=ineend=0,i=0,returnvalue,color;
char ch;
edity+=6;
zero_string1lon*/




_string moveto(editx,edity);outtext(st)
int lineend=0,i=0,rerror(filename)name)
char filename[16];
\x8') &name,"ab"))==NULL)                     t1,yt      /*p1,xler(filename);
strcpy(&erroror(filename)na	disp_FI);
	((bodyptr=fopen(filename,"ab"))==NULL)                       /*op23,142,22,-128,-1,1	file_error(se getimcolDt(&erroror(filename)na	disp_FI);
	((bodtcolor(colocpy(&erroror(filename)na	disp_5,13,83,15,79,1er,NOT_P[i]='13,68,10');
lineename18',file_r);ty);outtext(st)
int        /*reopen fI'5'	setco+(steppin7 end=1;exit(0);break;
		cat2,ytop2+(s16,97,220,104,20)*/
			st[i ");
fwrite(st,1,31,bodyptr);
}

initialize_graph()Iseall();
exitle_r);r);r);r);r);r);r);r);r);r);r);r+(steppin7 end=pages_no,cntr,markx,marky;
if ((fptr=fopen(filename,"r"))==NULL)v   /*of the statement by the statement next to it*/
	if (row==2               /*c		break;
		}se;ro_choice;}
		else
			{inverse_choice;choice=itemsno;inverse_chk=NULL)                     t1,yt      /*p1,xler(fi};
int europ		break;D,1};
	else
u7      t1,yt              1	fileep,items=itemsno;invkII_error(fiIce,excode =0,xcorde is no filename[^,64lse
			{inverse_choice;choice=itemsno;inverse_chk=NULL)      ,12,152,14,
148,13,145,21,143,18,146,14,138,8,135,8,132Iend=1;exit(0);break;
Dng mo(fptr=fopen(fk_letter(ch)
char ch;
{
int chc,foundyn=0;
for(chc=0;chc<=55;138,8,135,8,132Iend=1;exit(0);break;
Dng mo(fptr=fopen(fk_le..hdr");
strcpy(fname,filename);
setcolor(15);
}


write_hea,83,15,79,12,
74,13,69,13,68,10,64,10,62,7,64,3af ((fptr=fopen(filename,"r"))==NULL)       );
r0,208,43,21ing;
x
int pages_no,v   /*of the statement by the statement next to it*/
	eft1,ytop1+(step*choice),xleft1+width,(ytop1+stolor(0);
bar(left,top,right,bottom);
}

draw_map()
{
inptr=fopen(filename,"w"))==NULL)                  /*reopen for wrice getimage(xcord,ycord+(steppppppppppppe(f                   /*write initial pages no which is 0*/ statement by the statement next to it*/
	if (row==2 && checked()
{
int gdriver=EGA,21,46,35,31,oundyn=1;}
ret;
		}
	}
}

file_error(filename)name)
char filenamor(ch	if (row==2 *filenach==letkey[chc])
foundyn=1;}
return(foundyn);
}

zero_string               /*reopen for wr159,6,150,1nverstial hea,83,15,79,12,
74,13,69,13,68,10,64,10,62,7,6L
int,14draw_map()
{
int africa[]={-91,-185,90,179,92,181,94,175,98,17f (row==2               /*c		break;
		}se;ro_choice;}t to i
{
wr159,reppin7jth,(yto,NOT6,35,315A8



enEuHxuint gd      /*write7(st
{
A initial71,-49ot nex   t1, 0*/
	if9,repptop,righ,272b=1;exit2,181,in7 dity)
A initiCsrD1, e nnt,nitle_r5LOdErd,;138,8,135,8,132Iend1;exit2,.    /*c		break;
=0acho9,r6,97,220,eIt3,69,13,68,10,642atement 0,64,10,e h];
r159,6,15 o6L
E:Ot
	( no w129,279,1to d1ro_o)4,170,16,
169,16,16DS8',f EW   ffeca0,1R7,307,65,308,64,3,98,i,afAver=x,64,3,	_cher=EiE*/     pid      /*oEd1;e*write iUoh1x()
i0*/
	if,
160,18,158,17,158,9,159g	Rf7(s8En7/*c		bU}
		else
		n,yt              if (choic4n  Tse;ro_choice;}
		else
			{inverse_choice;choice=itemsno;inverse_chk=NULL)                     t1,yt      /*p1,xler(fi};
int europ		break;D,1};
	else
u7      t1,yt              1	fileep,items=itemsno;invkII_error(fiIce,excode =0,xcorde is no filename[^,64lse
			{inverse_choice;choice=itemsno;inverse_chk=NUListen=NUListe/u29,161 ,xler(uxcod   h65,H e,1};
75,en


  f ch;
edity+=6;
zero_strinbt2,ytop2+(s16,97,DB5,185};t ltpbf)chotems;138oL /*p     cpy72,290,6845,16d oica[rDsft1+width,(ytop1+stolor( eend=0,uAN   /*write initial payto    /74,264,66,
	}
,1};
   uint gdcpyn45,16d oitemenDB5,185};t ltpbf)chotems;138oL /*p     cpy72,290,6845,16d oica[rDsft1+wi